import * as input from "./input";
import { Key, MouseButton } from "./types";
import { MouseEvent, KeyboardEvent, KeyboardModifierKeysState, MouseButtonsState, isKeyboardEvent, isMouseEvent, startListening, stopListening } from "./input";
import { Tape, SerializedTape, KeyboardEventFilter, MouseEventFilter, eventMatchesFilter, keyboardEventFilter, mouseEventFilter } from "./recording";
import { Screen } from "./screen";
declare const Mouse: {
    onDown(button: MouseButton, eventHandler: (event: input.MouseEvent) => void): import("./types").Listener;
    onUp(button: MouseButton, eventHandler: (event: input.MouseEvent) => void): import("./types").Listener;
    onClick(button: MouseButton, eventHandler: (event: input.MouseEvent) => void): import("./types").Listener;
    onMove(eventHandler: (event: input.MouseEvent) => void): import("./types").Listener;
    isDown(button: MouseButton): boolean;
    isUp(button: MouseButton): boolean;
    moveTo(x: number, y: number): void;
    click(button?: MouseButton): void;
    doubleClick(button?: MouseButton): void;
    hold(button?: MouseButton): void;
    release(button?: MouseButton): void;
    getPosition(): {
        x: number;
        y: number;
    };
    scroll({ x, y }?: {
        x?: number | undefined;
        y?: number | undefined;
    }): void;
};
declare const Keyboard: {
    onDown(key: Key, eventHandler: (event: input.KeyboardEvent) => void): import("./types").Listener;
    onUp(key: Key, eventHandler: (event: input.KeyboardEvent) => void): import("./types").Listener;
    isDown(key: Key): boolean;
    isUp(key: Key): boolean;
    tap(key: Key): void;
    hold(key: Key): void;
    release(key: Key): void;
    type(textToType: string, delayBetweenKeyPresses?: number): void;
};
declare const sleep: ((milliseconds: number) => Promise<void>) & {
    sync: (milliseconds: number) => void;
    async: (milliseconds: number) => Promise<void>;
};
declare const sleepSync: (milliseconds: number) => void;
export { Mouse, Keyboard, MouseButton, Key, MouseEvent, KeyboardEvent, KeyboardModifierKeysState, MouseButtonsState, isKeyboardEvent, isMouseEvent, sleep, sleepSync, Screen, startListening, stopListening, KeyboardEventFilter, MouseEventFilter, eventMatchesFilter, keyboardEventFilter, mouseEventFilter, Tape, SerializedTape, };
