"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getModifierKeysState = exports.isKeyUp = exports.isKeyDown = exports.setKeyState = void 0;
var types_1 = require("../types");
var heldKeys = new Map();
function setKeyState(key, upOrDown) {
    if (key === types_1.Key.ANY) {
        return;
    }
    heldKeys.set(key, upOrDown === "down");
}
exports.setKeyState = setKeyState;
function isKeyDown(key) {
    var e_1, _a;
    if (key === types_1.Key.ANY) {
        try {
            for (var heldKeys_1 = __values(heldKeys), heldKeys_1_1 = heldKeys_1.next(); !heldKeys_1_1.done; heldKeys_1_1 = heldKeys_1.next()) {
                var _b = __read(heldKeys_1_1.value, 2), _key = _b[0], isDown = _b[1];
                if (isDown) {
                    return true;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (heldKeys_1_1 && !heldKeys_1_1.done && (_a = heldKeys_1.return)) _a.call(heldKeys_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return false;
    }
    else {
        return Boolean(heldKeys.get(key));
    }
}
exports.isKeyDown = isKeyDown;
function isKeyUp(key) {
    var e_2, _a;
    if (key === types_1.Key.ANY) {
        try {
            for (var heldKeys_2 = __values(heldKeys), heldKeys_2_1 = heldKeys_2.next(); !heldKeys_2_1.done; heldKeys_2_1 = heldKeys_2.next()) {
                var _b = __read(heldKeys_2_1.value, 2), _key = _b[0], isDown = _b[1];
                if (!isDown) {
                    return true;
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (heldKeys_2_1 && !heldKeys_2_1.done && (_a = heldKeys_2.return)) _a.call(heldKeys_2);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return false;
    }
    else {
        return !heldKeys.get(key);
    }
}
exports.isKeyUp = isKeyUp;
function getModifierKeysState() {
    var leftAlt = Boolean(heldKeys.get(types_1.Key.LEFT_ALT));
    var leftControl = Boolean(heldKeys.get(types_1.Key.LEFT_CONTROL));
    var leftShift = Boolean(heldKeys.get(types_1.Key.LEFT_SHIFT));
    var leftSuper = Boolean(heldKeys.get(types_1.Key.LEFT_SUPER));
    var rightAlt = Boolean(heldKeys.get(types_1.Key.RIGHT_ALT));
    var rightControl = Boolean(heldKeys.get(types_1.Key.RIGHT_CONTROL));
    var rightShift = Boolean(heldKeys.get(types_1.Key.RIGHT_SHIFT));
    var rightSuper = Boolean(heldKeys.get(types_1.Key.RIGHT_SUPER));
    var alt = leftAlt || rightAlt;
    var control = leftControl || rightControl;
    var shift = leftShift || rightShift;
    var super_ = leftSuper || rightSuper;
    return {
        alt: alt,
        control: control,
        shift: shift,
        super: super_,
        windows: super_,
        command: super_,
        meta: super_,
        leftAlt: leftAlt,
        leftControl: leftControl,
        leftShift: leftShift,
        leftSuper: leftSuper,
        leftWindows: leftSuper,
        leftCommand: leftSuper,
        leftMeta: leftSuper,
        rightAlt: rightAlt,
        rightControl: rightControl,
        rightShift: rightShift,
        rightSuper: rightSuper,
        rightWindows: rightSuper,
        rightCommand: rightSuper,
        rightMeta: rightSuper,
    };
}
exports.getModifierKeysState = getModifierKeysState;
