"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMouseButtonsState = exports.isButtonUp = exports.isButtonDown = exports.setButtonState = void 0;
var types_1 = require("../types");
var heldButtons = new Map();
function setButtonState(button, upOrDown) {
    if (button === types_1.MouseButton.ANY) {
        return;
    }
    heldButtons.set(button, upOrDown === "down");
}
exports.setButtonState = setButtonState;
function isButtonDown(button) {
    var e_1, _a;
    if (button === types_1.MouseButton.ANY) {
        try {
            for (var heldButtons_1 = __values(heldButtons), heldButtons_1_1 = heldButtons_1.next(); !heldButtons_1_1.done; heldButtons_1_1 = heldButtons_1.next()) {
                var _b = __read(heldButtons_1_1.value, 2), _key = _b[0], isDown = _b[1];
                if (isDown) {
                    return true;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (heldButtons_1_1 && !heldButtons_1_1.done && (_a = heldButtons_1.return)) _a.call(heldButtons_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return false;
    }
    else {
        return Boolean(heldButtons.get(button));
    }
}
exports.isButtonDown = isButtonDown;
function isButtonUp(button) {
    var e_2, _a;
    if (button === types_1.MouseButton.ANY) {
        try {
            for (var heldButtons_2 = __values(heldButtons), heldButtons_2_1 = heldButtons_2.next(); !heldButtons_2_1.done; heldButtons_2_1 = heldButtons_2.next()) {
                var _b = __read(heldButtons_2_1.value, 2), _key = _b[0], isDown = _b[1];
                if (!isDown) {
                    return true;
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (heldButtons_2_1 && !heldButtons_2_1.done && (_a = heldButtons_2.return)) _a.call(heldButtons_2);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return false;
    }
    else {
        return !heldButtons.get(button);
    }
}
exports.isButtonUp = isButtonUp;
function getMouseButtonsState() {
    var left = Boolean(heldButtons.get(types_1.MouseButton.LEFT));
    var right = Boolean(heldButtons.get(types_1.MouseButton.RIGHT));
    var middle = Boolean(heldButtons.get(types_1.MouseButton.MIDDLE));
    var mouse4 = Boolean(heldButtons.get(types_1.MouseButton.MOUSE4));
    var mouse5 = Boolean(heldButtons.get(types_1.MouseButton.MOUSE5));
    return {
        left: left,
        right: right,
        middle: middle,
        mouse4: mouse4,
        mouse5: mouse5,
    };
}
exports.getMouseButtonsState = getMouseButtonsState;
