import { Key, Listener } from "../types";
import { KeyboardModifierKeysState } from "./held-keys";
import { MouseButtonsState } from "./held-mouse-buttons";
declare const IS_KEYBOARD_EVENT: unique symbol;
export declare function isKeyboardEvent(event: any): event is KeyboardEvent;
export declare class KeyboardEvent {
    type: "down" | "up";
    key: Key;
    modifierKeys: KeyboardModifierKeysState;
    mouseButtons: MouseButtonsState;
    [IS_KEYBOARD_EVENT]: true;
    constructor(type: "down" | "up", key: Key, modifierKeys?: KeyboardModifierKeysState, mouseButtons?: MouseButtonsState);
}
export declare const Keyboard: {
    onDown(key: Key, eventHandler: (event: KeyboardEvent) => void): Listener;
    onUp(key: Key, eventHandler: (event: KeyboardEvent) => void): Listener;
    isDown(key: Key): boolean;
    isUp(key: Key): boolean;
};
export {};
