import { MouseButton, Listener } from "../types";
import { KeyboardModifierKeysState } from "./held-keys";
import { MouseButtonsState } from "./held-mouse-buttons";
declare const IS_MOUSE_EVENT: unique symbol;
export declare function isMouseEvent(event: any): event is MouseEvent;
export declare class MouseEvent {
    type: "click" | "down" | "up" | "move";
    button: MouseButton | null;
    x: number;
    y: number;
    modifierKeys: KeyboardModifierKeysState;
    mouseButtons: MouseButtonsState;
    [IS_MOUSE_EVENT]: true;
    constructor(type: "click" | "down" | "up" | "move", button: MouseButton | null, x: number, y: number, modifierKeys?: KeyboardModifierKeysState, mouseButtons?: MouseButtonsState);
}
export declare const Mouse: {
    onDown(button: MouseButton, eventHandler: (event: MouseEvent) => void): Listener;
    onUp(button: MouseButton, eventHandler: (event: MouseEvent) => void): Listener;
    onClick(button: MouseButton, eventHandler: (event: MouseEvent) => void): Listener;
    onMove(eventHandler: (event: MouseEvent) => void): Listener;
    isDown(button: MouseButton): boolean;
    isUp(button: MouseButton): boolean;
};
export {};
