"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Mouse = void 0;
var types_1 = require("../types");
var libnut = __importStar(require("@nut-tree/libnut"));
var a_mimir_1 = require("a-mimir");
var mouseButtonToNutMap = {
    LEFT: "left",
    RIGHT: "right",
    MIDDLE: "middle",
    MOUSE4: null,
    MOUSE5: null,
    ANY: null,
};
function mouseButtonToNut(button) {
    if (button === types_1.MouseButton.ANY) {
        throw new Error("The \"ANY\" mouse button is for input listeners only; it can't be pressed/released");
    }
    var result = mouseButtonToNutMap[button];
    if (result == null) {
        throw new Error("Pressing/releasing the following mouse button is not yet supported: " +
            button);
    }
    return result;
}
exports.Mouse = {
    moveTo: function (x, y) {
        libnut.moveMouse(x, y);
    },
    click: function (button) {
        if (button === void 0) { button = types_1.MouseButton.LEFT; }
        var nutButton = mouseButtonToNut(button);
        libnut.mouseToggle("down", nutButton);
        a_mimir_1.sleep.sync(4);
        libnut.mouseToggle("up", nutButton);
    },
    doubleClick: function (button) {
        if (button === void 0) { button = types_1.MouseButton.LEFT; }
        var nutButton = mouseButtonToNut(button);
        libnut.mouseToggle("down", nutButton);
        a_mimir_1.sleep.sync(4);
        libnut.mouseToggle("up", nutButton);
        a_mimir_1.sleep.sync(4);
        libnut.mouseToggle("down", nutButton);
        a_mimir_1.sleep.sync(4);
        libnut.mouseToggle("up", nutButton);
    },
    hold: function (button) {
        if (button === void 0) { button = types_1.MouseButton.LEFT; }
        var nutButton = mouseButtonToNut(button);
        libnut.mouseToggle("down", nutButton);
    },
    release: function (button) {
        if (button === void 0) { button = types_1.MouseButton.LEFT; }
        var nutButton = mouseButtonToNut(button);
        libnut.mouseToggle("up", nutButton);
    },
    getPosition: function () {
        return libnut.getMousePos();
    },
    scroll: function (_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.x, x = _c === void 0 ? 0 : _c, _d = _b.y, y = _d === void 0 ? 0 : _d;
        libnut.scrollMouse(x, y);
    },
};
