import { MouseEvent, KeyboardEvent, KeyboardModifierKeysState } from "../input";
import { MouseButton, Key } from "../types";
export declare type MouseEventFilter = {
    filterType: "Mouse";
    type?: "click" | "down" | "up" | "move";
    button?: MouseButton;
    x?: number;
    y?: number;
};
export declare type KeyboardEventFilter = {
    filterType: "Keyboard";
    type?: "down" | "up";
    key?: Key;
    modifierKeys?: Partial<KeyboardModifierKeysState>;
};
export declare function mouseEventFilter(criteria?: {
    type?: "click" | "down" | "up" | "move";
    button?: MouseButton;
    x?: number;
    y?: number;
}): MouseEventFilter;
export declare function keyboardEventFilter(criteria?: {
    type?: "down" | "up";
    key?: Key;
    modifierKeys?: Partial<KeyboardModifierKeysState>;
}): KeyboardEventFilter;
export declare function eventMatchesFilter(event: MouseEvent | KeyboardEvent, filter: MouseEventFilter | KeyboardEventFilter): boolean;
