import { MouseEvent, KeyboardEvent } from "../input";
export declare type RecordedAction = {
    event: MouseEvent | KeyboardEvent;
    time: number;
};
export declare class TapeData {
    actions: Array<RecordedAction>;
    get length(): number;
    constructor(actions: Array<RecordedAction>);
    static deserialize(data: SerializedTapeData): TapeData;
    serialize(): SerializedTapeData;
}
export declare type SerializedMouseEvent = {
    $kind: "MouseEvent";
    type: MouseEvent["type"];
    button: MouseEvent["button"];
    x: number;
    y: number;
};
export declare type SerializedKeyboardEvent = {
    $kind: "KeyboardEvent";
    type: KeyboardEvent["type"];
    key: KeyboardEvent["key"];
};
export declare type SerializedTapeData = {
    $kind: "TapeData";
    actions: Array<{
        $kind: "RecordedAction";
        time: number;
        event: SerializedMouseEvent | SerializedKeyboardEvent;
    }>;
};
