import { SerializedTapeData, TapeData } from "./tape-data";
import { KeyboardEventFilter, MouseEventFilter } from "./event-filters";
declare const DATA: unique symbol;
declare const CURRENT_STATE: unique symbol;
declare const EVENTS_TO_IGNORE: unique symbol;
declare const RECORDER: unique symbol;
declare const PLAYER: unique symbol;
declare type TapeState = string & {
    __type: "TapeState";
};
declare const TapeState: {
    RECORDING: TapeState;
    PLAYING: TapeState;
    IDLE: TapeState;
};
export declare type SerializedTape = {
    $kind: "Tape";
    eventsToIgnore: Array<KeyboardEventFilter | MouseEventFilter>;
    data: SerializedTapeData;
};
export declare class Tape {
    static State: {
        RECORDING: TapeState;
        PLAYING: TapeState;
        IDLE: TapeState;
    };
    private [DATA];
    private [CURRENT_STATE];
    private [EVENTS_TO_IGNORE];
    private [RECORDER];
    private [PLAYER];
    constructor(eventsToIgnore?: Array<KeyboardEventFilter | MouseEventFilter>, data?: TapeData);
    get state(): TapeState;
    record(): void;
    stopRecording(): void;
    play(): Promise<void>;
    stopPlaying(): void;
    serialize(): SerializedTape;
    static deserialize(serialized: SerializedTape): Tape;
}
export {};
